#include "GWt_beam.h"
#include "mixedTools.h"

#include <Wt/WText>
#include <Wt/WLineEdit>
#include <Wt/WBreak>
#include <Wt/WDialog>
#include <Wt/WPushButton>

GWt_beam::GWt_beam(abstractElement* elem) : GWt_abstractElement(elem) {
    
    
    string* param = beginDialog();
    
    new WText(" 1/2 horizontal beam extend rms (cm) : ",dialog_->contents());
    xEdit_ = new WLineEdit(param->c_str(), dialog_->contents());
    //  new WBreak(dialog_->contents());
    
    new WText("1/2 horizontal beam divergence rms (mrad) : ",dialog_->contents());
    xpEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
    new WBreak(dialog_->contents());
    
    new WText("1/2 vertical beam extend rms (cm) : ",dialog_->contents());
    yEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
    //  new WBreak(dialog_->contents());
    
    new WText("1/2 horizontal beam divergence rms (mrad) : ",dialog_->contents());
    ypEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
    new WBreak(dialog_->contents());
    
    new WText("1/2 longitudinal beam extend rms (cm) : ",dialog_->contents());
    dlEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
    //  new WBreak(dialog_->contents());
    
    new WText("1/2 momentum spread rms (mrad) : ",dialog_->contents());
    delEdit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
    new WBreak(dialog_->contents());
    
    new WText("momentum of the central trajectory (GeV/c) : ",dialog_->contents());
    p0Edit_ = new WLineEdit( (++param)->c_str(), dialog_->contents());
    new WBreak(dialog_->contents());
    
    WPushButton *submit = new WPushButton("OK",dialog_->contents());
    submit->clicked().connect(dialog_, &Wt::WDialog::accept);
    dialog_->finished().connect(this, &GWt_beam::dialogDone);
    
    // make image
    image_ = new WImage("htdocs/beam.jpg",this);
    
    // activate slots
    image_->clicked().connect(this,&GWt_abstractElement::clicked);
    
}

void GWt_beam::dialogDone()
{
    unsigned nbParam = abstractElement_->getNbParams();
    string* envoi = new string[nbParam+1];
    int compteur = -1;
    envoi[++compteur] = mixedTools::intToString(nbParam);
    envoi[++compteur] = labelEdit_->text().toUTF8();
    envoi[++compteur] = xEdit_->text().toUTF8();
    envoi[++compteur] = xpEdit_->text().toUTF8();
    envoi[++compteur] = yEdit_->text().toUTF8();
    envoi[++compteur] = ypEdit_->text().toUTF8();
    envoi[++compteur] = dlEdit_->text().toUTF8();
    envoi[++compteur] = delEdit_->text().toUTF8();
    envoi[++compteur] = p0Edit_->text().toUTF8();
    if ( compteur !=  (int)nbParam ) {
        cerr << " GWt_beam::dialogDone() pb nb de parametres, compteur = " << compteur << " nbParam= " << nbParam << endl;
        return;
    }
    abstractElement_->setParametersString(envoi);
    updateLabelWidget();
    delete [] envoi;
}

WImage* GWt_beam::getImage() {
    return image_;
}


WString GWt_beam::print(){
    return WString(abstractElement_->print());
}
